#this is the makfile for the Open Object Library (OS/2 version, EMX compiler)
#nessesary tools:
#gnu make
#emx 0.9c, emx multimedia package, jempower
#librarys for rexx and java must be build first, see documentation


COMPILE=gcc -c -Zmtd -Zcrtdll -Zdll -Zomf -fhandle-exceptions -frtti -b -s
LINK=gcc -Zmtd -Zcrtdll -Zomf -Zdll -Zlinker /PACKC -Zlinker /PACKD -o 

#DLLs to build
ALL: OOLW3E03.DLL OOLM3E03.DLL OOLJ3E03.DLL

#the object-files for window stuff
OBJ_MAIN=xapp.obj xbookpg.obj xbutton.obj xchart.obj xcolor.obj xcircsld.obj xclipbrd.obj xcont.obj xcontain.obj xcontrol.obj xdde.obj xdialog.obj xentry.obj xesem.obj xevent.obj xexcept.obj xfile.obj\
		xfileinf.obj xfiledlg.obj xfilefi.obj xfontdlg.obj xframe.obj xfrmcnt.obj xfrmwnd.obj xgraphdv.obj xgraphob.obj xhandler.obj xhelp.obj xlistbox.obj xmenu.obj\
		xmle.obj xmsgbox.obj xmusem.obj xnotebk.obj xnpipe.obj xpipe.obj xprofile.obj xprint.obj xrexx.obj xreslib.obj xscrlbar.obj xscrlwnd.obj xslider.obj xspinbtn.obj xstatic.obj\
		xstring.obj xthread.obj xtime.obj xtoolbar.obj xvaluset.obj xuserbtn.obj xuserwnd.obj xwindow.obj xwindrag.obj

#the object files for multimedia stuff
OBJ_MEDIA=xmedia.obj xgraphbt.obj xvirtscr.obj xbltwnd.obj xpal.obj xblitter.obj

#the object files for java
OBJ_JAVA=xjavaenv.obj xjvcmsgh.obj xjavaapp.obj xjvsmsgh.obj xjvsurlh.obj


#how to build the objects
%.obj: %.cpp
	$(COMPILE) $<


#how to build the window-related dll
#the library rexx2emx.lib must be build from the developers toolkit librarys,
#see ool.htm for details
OOLW3E03.DLL: $(OBJ_MAIN)
	emxexp -n -o $(OBJ_MAIN) > imp.tmp
	copy emx_w.def + imp.tmp OOLW3E03.def
	$(LINK) OOLW3E03.DLL $(OBJ_MAIN) c:\emx\lib\rexx2emx.lib OOLW3E03.def -lstdcpp
	emximp -o OOLW3E03.LIB OOLW3E03.DEF
	copy OOLW3E03.lib $(OOL)\lib
	copy OOLW3E03.DLL $(OOL)\lib


#how to build the multimedia-related dll
OOLM3E03.DLL: $(OBJ_MEDIA)
	emxexp -n -o $(OBJ_MEDIA) > imp2.tmp
	copy emx_m.def + imp2.tmp OOLM3E03.def
	$(LINK) OOLM3E03.DLL $(OBJ_MEDIA) $(OOL)\lib\OOLW3E03.lib c:\emx\lib\mm2emx.lib c:\emx\lib\oolimp.lib OOLM3E03.def -lstdcpp
	emximp -o OOLM3E03.LIB OOLM3E03.DEF
	copy OOLM3E03.lib $(OOL)\lib
	copy OOLM3E03.DLL $(OOL)\lib


#how to build the java-related dll
OOLJ3E03.DLL: $(OBJ_JAVA)
	emxexp -n -o $(OBJ_JAVA) > imp3.tmp
	copy emx_j.def + imp3.tmp OOLJ3E03.def
	$(LINK) OOLJ3E03.DLL $(OBJ_JAVA) $(OOL)\lib\OOLW3E03.lib c:\emx\lib\java2emx.lib OOLJ3E03.def -lstdcpp
	emximp -o OOLJ3E03.LIB OOLJ3E03.DEF
	copy OOLJ3E03.lib $(OOL)\lib
	copy OOLJ3E03.DLL $(OOL)\lib


#dependencies
xexcept.obj: xexcept.cpp

xapp.obj: xapp.cpp\
	c:\source\ool\include\xapp.h\
	$(OOL)\include\xreslib.h\
	$(OOL)\include\xrect.h\
	$(OOL)\include\xframe.h\
	$(OOL)\include\xfrmwnd.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\xcountry.h

xbookpg.obj: xbookpg.cpp\
	$(OOL)\include\XNoteBk.h\
	$(OOL)\include\XBookPg.h\
	$(OOL)\include\xcntevnt.h\
	$(OOL)\include\xcolor.h\
	$(OOL)\include\xexcept.h\
	$(OOL)\include\xres.h\
	$(OOL)\include\xreslib.h\
	$(OOL)\include\xbitmap.h

xbutton.obj: xbutton.cpp\
	$(OOL)\include\xcheckbx.h\
	$(OOL)\include\xpushbtn.h\
	$(OOL)\include\xradio.h\
	$(OOL)\include\xuserbtn.h\
	$(OOL)\include\xstring.h

xchart.obj: xchart.cpp\
	$(OOL)\include\XPie.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\xrect.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\xbar.h

xcircsld.obj: xcircsld.cpp\
	$(OOL)\include\xcircsld.h

xclipbrd.obj: xclipbrd.cpp\
	$(OOL)\include\XClipBrd.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XBitmap.h\
	$(OOL)\include\XString.h

xcolor.obj: xcolor.cpp\
	$(OOL)\include\xcolor.h

xcont.obj: xcont.cpp\
	$(OOL)\include\XContInf.h\
	$(OOL)\include\XContObj.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XContain.h\
	$(OOL)\include\XContCol.h\
	$(OOL)\include\XDate.h\
	$(OOL)\include\XTime.h\
	$(OOL)\include\XBitmap.h\
	$(OOL)\include\XIcon.h

xcontain.obj: xcontain.cpp\
	$(OOL)\include\XContain.h\
	$(OOL)\include\XContInf.h\
	$(OOL)\include\XContObj.h\
	$(OOL)\include\XControl.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XContCol.h

xcontrol.obj: xcontrol.cpp\
	$(OOL)\include\XControl.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\XPushBtn.h\
	$(OOL)\include\XDragHdl.h\
	$(OOL)\include\XDragEvn.h\
	$(OOL)\include\XMousHdl.h\
	$(OOL)\include\XMousEvn.h\
	$(OOL)\include\XFrame.h\
	$(OOL)\include\XNoteBk.h\
	$(OOL)\include\xcolor.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\xexcept.h\
	$(OOL)\include\XFrmWnd.h\
	$(OOL)\include\XObjWnd.h\
	$(OOL)\include\xrect.h\
	$(OOL)\include\XColor.h

xdde.obj: xdde.cpp\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XDDE.h\
	$(OOL)\include\XDefHdl.h\
	$(OOL)\include\xprocess.h

xdialog.obj: xdialog.cpp

xentry.obj: xentry.cpp\
	$(OOL)\include\xentry.h

xevent.obj: xevent.cpp\
	$(OOL)\include\XCntrevn.h\
	$(OOL)\include\XDragEvn.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XPoint.h\
	$(OOL)\include\XBitmap.h\
	$(OOL)\include\XDragItm.h\
	$(OOL)\include\XMousevn.h\
	$(OOL)\include\XCntEvnt.h\
	$(OOL)\include\XKeyEvnt.h\
	$(OOL)\include\XContObj.h\
	$(OOL)\include\XcnDrEvn.h\
	$(OOL)\include\XCnEdEvn.h\
	$(OOL)\include\xString.h\
	$(OOL)\include\XContCol.h\
	$(OOL)\include\XItmDEvn.h\
	$(OOL)\include\XBackEvn.h

xfile.obj: xfile.cpp\
	$(OOL)\include\XFileInf.h\
	$(OOL)\include\XFile.h

xfiledlg.obj: xfiledlg.cpp\
	$(OOL)\include\xfiledlg.h\
	$(OOL)\include\xwindow.h

xfilefi.obj: xfilefi.cpp\
	$(OOL)\include\XFileFi.h

xfileinf.obj: xfileinf.cpp\
	$(OOL)\include\xfileinf.h\
	$(OOL)\include\XDate.h\
	$(OOL)\include\XTime.h

xfontdlg.obj: xfontdlg.cpp\
	$(OOL)\include\xfontdlg.h

xframe.obj: xframe.cpp\
	$(OOL)\include\XFrmWnd.h\
	$(OOL)\include\XFrame.h\
	$(OOL)\include\XFrmCnt.h\
	$(OOL)\include\XScrlBar.h\
	$(OOL)\include\XRect.h

xfrmcnt.obj: xfrmcnt.cpp\
	$(OOL)\include\XFrmCnt.h\
	$(OOL)\include\XFrmwnd.h\
	$(OOL)\include\XFrame.h

xfrmwnd.obj: xfrmwnd.cpp\
	$(OOL)\include\XFrmwnd.h\
	$(OOL)\include\xexcept.h\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XFrame.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\XCombo.H\
	$(OOL)\include\XMLE.h\
	$(OOL)\include\XSlider.h\
	$(OOL)\include\XEntry.h\
	$(OOL)\include\XCheckBx.h\
	$(OOL)\include\XPushBtn.h\
	$(OOL)\include\XScrlBar.h\
	$(OOL)\include\XSpinBtn.h\
	$(OOL)\include\XListBox.h\
	$(OOL)\include\XCircSld.h\
	$(OOL)\include\XGroupBx.h\
	$(OOL)\include\XSBitmap.h\
	$(OOL)\include\XSIcon.h\
	$(OOL)\include\XSText.h\
	$(OOL)\include\XSFrame.h\
	$(OOL)\include\XValuSet.h\
	$(OOL)\include\XIcon.h\
	$(OOL)\include\XRadio.h\
	$(OOL)\include\XMenuBar.h\
	$(OOL)\include\XContain.h\
	$(OOL)\include\XProcess.h\
	$(OOL)\include\Xcntrevn.h\
	$(OOL)\include\XMedia.h\
	$(OOL)\include\XTimer.h\
	$(OOL)\include\XDragHdl.h\
	$(OOL)\include\XDragEvn.h\
	$(OOL)\include\XMousHdl.h\
	$(OOL)\include\XMousevn.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XContHdl.h\
	$(OOL)\include\XItmDHdl.h\
	$(OOL)\include\XBackHdl.h\
	$(OOL)\include\XStylHdl.h\
	$(OOL)\include\XdefHdl.h\
	$(OOL)\include\XTimer.h\
	$(OOL)\include\XScrlWnd.h\
	$(OOL)\include\XCntEvnt.h\
	$(OOL)\include\XCnEdEvn.h\
	$(OOL)\include\XCndrEvn.h\
	$(OOL)\include\xkeyevnt.h\
	$(OOL)\include\xkeybhdl.h\
	$(OOL)\include\XItmDEvn.h\
	$(OOL)\include\XBackEvn.h\
	$(OOL)\include\XNoteBk.h

xgraphbt.obj: xgraphbt.cpp\
	$(OOL)\include\xgraphbt.h\
	$(OOL)\include\XColor.h

xgraphdv.obj: xgraphdv.cpp\
	$(OOL)\include\XGraphDv.h\
	$(OOL)\include\XGraphOb.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XFont.h

xgraphob.obj: xgraphob.cpp\
	$(OOL)\include\XGraphOb.h\
	$(OOL)\include\XGraphDv.h\
	$(OOL)\include\XLine.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\XFont.h\
	$(OOL)\include\XCircle.h\
	$(OOL)\include\XText.h\
	$(OOL)\include\XBox.h\
	$(OOL)\include\XMarker.h\
	$(OOL)\include\XBitmap.h\
	$(OOL)\include\XFile.h\
	$(OOL)\include\XFileInf.h\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XBmpShad.h\
	$(OOL)\include\XArc.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\xexcept.h\
	$(OOL)\include\XUserBtn.h

xhandler.obj: xhandler.cpp\
	$(OOL)\include\XDragHdl.h\
	$(OOL)\include\XDragEvn.h\
	$(OOL)\include\XMousHdl.h\
	$(OOL)\include\XMousevn.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XContHdl.h\
	$(OOL)\include\XItmDHdl.h\
	$(OOL)\include\XBackHdl.h\
	$(OOL)\include\XStylHdl.h\
	$(OOL)\include\XTimer.h

xhelp.obj: xhelp.cpp\
	$(OOL)\include\XHelp.h\
	$(OOL)\include\XFrmwnd.H\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XProcess.h

xjavaapp.obj: xjavaapp.cpp\
	$(OOL)\include\xheaders.h\
	$(OOL)\include\XJavaApp.h

xjavaenv.obj: xjavaenv.cpp\
	$(OOL)\include\xheaders.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\xjavaenv.h\
	$(OOL)\include\xjvcmsgh.h\
	$(OOL)\include\xjvsurlh.h\
	$(OOL)\include\xjvsmsgh.h

xjvcmsgh.obj: xjvcmsgh.cpp\
	$(OOL)\include\xheaders.h\
	$(OOL)\include\XJavaEnv.h\
	$(OOL)\include\XJvCMsgH.h

xjvsmsgh.obj: xjvsmsgh.cpp

xjvsurlh.obj: xjvsurlh.cpp

xlistbox.obj: xlistbox.cpp\
	$(OOL)\include\xlistbox.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\xcombo.h

xmedia.obj: xmedia.cpp\
	$(OOL)\include\XVideo.h\
	$(OOL)\include\XFrmWnd.h\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XSound.h\
	$(OOL)\include\XCntrEvn.h

xmenu.obj: xmenu.cpp\
	$(OOL)\include\XPopMenu.h\
	$(OOL)\include\XMenuBar.h\
	$(OOL)\include\XMenuItm.h\
	$(OOL)\include\XPoint.h\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XFrmWnd.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\xexcept.h

xmle.obj: xmle.cpp\
	$(OOL)\include\xmle.h\
	$(OOL)\include\xmlesear.h\
	$(OOL)\include\xstring.h

xmsgbox.obj: xmsgbox.cpp\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XxtMsgBx.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XIcon.h

xnotebk.obj: xnotebk.cpp\
	$(OOL)\include\xnotebk.h\
	$(OOL)\include\XBookPg.h

xnpipe.obj: xnpipe.cpp\
	$(OOL)\include\XNPipe.h\
	$(OOL)\include\XcPipe.h

xpipe.obj: xpipe.cpp\
	$(OOL)\include\XPipe.h

xprint.obj: xprint.cpp\
	$(OOL)\include\XCheckBx.h\
	$(OOL)\include\XListBox.h\
	$(OOL)\include\XEntry.h\
	$(OOL)\include\XCntrevn.h\
	$(OOL)\include\xfont.h\
	$(OOL)\include\XFrmwnd.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\XReslib.h\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XExcept.h\
	$(OOL)\include\oolprint.h\
	$(OOL)\include\xcountry.h\
	$(OOL)\include\xprint.h\
	$(OOL)\include\xgraphob.h

xprofile.obj: xprofile.cpp\
	$(OOL)\include\xprofile.h

xreslib.obj: xreslib.cpp\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XApp.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XIcon.h\
	$(OOL)\include\xexcept.h

xrexx.obj: xrexx.cpp\
	$(OOL)\include\xrexx.h\
	$(OOL)\include\xexcept.h

xscrlbar.obj: xscrlbar.cpp\
	$(OOL)\include\xscrlbar.h

xscrlwnd.obj: xscrlwnd.cpp\
	$(OOL)\include\XScrlWnd.h\
	$(OOL)\include\xrect.h\
	$(OOL)\include\XScrlBar.h\
	$(OOL)\include\XFrame.h\
	$(OOL)\include\XDefhdl.h\
	$(OOL)\include\xexcept.h

xslider.obj: xslider.cpp\
	$(OOL)\include\xslider.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\xindicat.h

xspinbtn.obj: xspinbtn.cpp\
	$(OOL)\include\xspinbtn.h

xstatic.obj: xstatic.cpp\
	$(OOL)\include\XSIcon.h\
	$(OOL)\include\XSFrame.h\
	$(OOL)\include\XSBitmap.h\
	$(OOL)\include\XGroupBx.h\
	$(OOL)\include\XSText.h\
	$(OOL)\include\xcontrol.h

xstring.obj: xstring.cpp\
	$(OOL)\include\XString.h

xthread.obj: xthread.cpp\
	$(OOL)\include\xthread.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\xexcept.h

xtime.obj: xtime.cpp\
	$(OOL)\include\xtime.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\xdate.h

xtoolbar.obj: xtoolbar.cpp\
	$(OOL)\include\XToolBar.h\
	$(OOL)\include\XFrmWnd.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\XFrame.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\XGraphDv.H\
	$(OOL)\include\XLine.h\
	$(OOL)\include\XCntrEvn.h\
	$(OOL)\include\XMousHdl.h\
	$(OOL)\include\XMousevn.h\
	$(OOL)\include\XReslib.h\
	$(OOL)\include\xmsgbox.h

xuserbtn.obj: xuserbtn.cpp\
	$(OOL)\include\xuserbtn.h\
	$(OOL)\include\xdefhdl.h\
	$(OOL)\include\xmoushdl.h\
	$(OOL)\include\xmousevn.h\
	$(OOL)\include\xbitmap.h\
	$(OOL)\include\XLine.h\
	$(OOL)\include\xbox.h\
	$(OOL)\include\xfont.h

xuserwnd.obj: xuserwnd.cpp\
	$(OOL)\include\xuserwnd.h\
	$(OOL)\include\xrect.h\
	$(OOL)\include\xexcept.h\
	$(OOL)\include\xcntrevn.h\
	$(OOL)\include\xreslib.h\
	$(OOL)\include\xbubble.h\
	$(OOL)\include\xtimer.h\
	$(OOL)\include\xbitmap.h\
	$(OOL)\include\xgraphdv.h\
	$(OOL)\include\xres.h\
	$(OOL)\include\xprocess.h\
	$(OOL)\include\xmoushdl.h\
	$(OOL)\include\xfont.h\
	$(OOL)\include\xmousevn.h\
	$(OOL)\include\XText.h

xvaluset.obj: xvaluset.cpp\
	$(OOL)\include\xvaluset.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\xcolor.h\
	$(OOL)\include\xicon.h\
	$(OOL)\include\xbitmap.h

xwebview.obj: xwebview.cpp\
	$(OOL)\include\XControl.h\
	$(OOL)\include\XWebView.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\webexwin.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\XDefHdl.h

xwindow.obj: xwindow.cpp\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\XHandler.h\
	$(OOL)\include\XPoint.h

xwindrag.obj: xwindrag.cpp\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XWinDrag.h\
	$(OOL)\include\XDragItm.h\
	$(OOL)\include\XBitmap.h\
	$(OOL)\include\XIcon.h

clean:
	del *.s *.map *.tmp *.lib *.dll

