#
# Makefile for OOL - Watcom C/C++
#

#
# Directories
#
OOLLIB     = $(OOL)\lib
OOLINC     = $(OOL)\include
OOLSRC     = $(OOL)source

#
# Compiler and linker definitions
#
CC              = wpp386
LD              = wlink

CCDBGFLGS       = -bd -bm -bt=os2 -d2 -4r -otexan -xst -zq
CCNODBGFLGS     = -bd -bm -bt=os2 -4r -otexan -xst -zq
CCFLAGS         = $(CCDBGFLGS)

OBJFILE         = watcom.lnk
LDDBGFLGS       = debug all format os2 flat dll initinstance terminstance option protmode, many, stack=36000, quiet @$(OBJFILE)
LDNODBGFLGS     = format os2 flat dll initi termi option protmode, many, stack=36000, quiet @$(OBJFILE)
LDFLAGS         = $(LDNODBGFLGS)

OBJ_MAIN        = xapp.obj xbookpg.obj xrexx.obj xbutton.obj xchart.obj xcolor.obj xprint.obj xcircsld.obj xclipbrd.obj xcont.obj xcontain.obj xcontrol.obj xdde.obj xentry.obj xevent.obj xfile.obj xfilefi.obj xfiledlg.obj xfileinf.obj xfontdlg.obj xframe.obj xfrmcnt.obj xfrmwnd.obj xgraphdv.obj xgraphob.obj xhandler.obj xhelp.obj xlistbox.obj xmenu.obj xmle.obj xmsgbox.obj xprofile.obj xreslib.obj xscrlbar.obj xscrlwnd.obj xslider.obj xspinbtn.obj xstatic.obj xstring.obj xthread.obj xtime.obj xtoolbar.obj xvaluset.obj xuserwnd.obj xwindow.obj xwindrag.obj
LOBJ_MAIN       = xapp.obj, xbookpg.obj, xrexx.obj, xbutton.obj, xchart.obj, xcolor.obj, xprint.obj, xcircsld.obj, xclipbrd.obj, xcont.obj, xcontain.obj, xcontrol.obj, xdde.obj, xentry.obj, xevent.obj, xfile.obj, xfilefi.obj, xfiledlg.obj, xfileinf.obj, xfontdlg.obj, xframe.obj, xfrmcnt.obj, xfrmwnd.obj, xgraphdv.obj, xgraphob.obj, xhandler.obj, xhelp.obj, xlistbox.obj, xmenu.obj, xmle.obj, xmsgbox.obj, xprofile.obj, xreslib.obj, xscrlbar.obj, xscrlwnd.obj, xslider.obj, xspinbtn.obj, xstatic.obj, xstring.obj, xthread.obj, xtime.obj, xtoolbar.obj, xvaluset.obj, xuserwnd.obj, xwindow.obj, xwindrag.obj
OBJ_MEDIA       = xmedia.obj xgraphbt.obj xblitter.obj xbltwnd.obj xpal.obj xvirtscr.obj
LOBJ_MEDIA      = xmedia.obj, xgraphbt.obj, xblitter.obj, xbltwnd.obj, xpal.obj, xvirtscr.obj
OBJ_TCP         = xwebview.obj
LOBJ_TCP        = xwebview.obj
OBJ_JAVA        = xjavaenv.obj xjvcmsgh.obj xjavaapp.obj
LOBJ_JAVA       = xjavaenv.obj, xjvcmsgh.obj, xjavaapp.obj
OBJ_DB          = xtable.obj
LOBJ_DB         = xtable.obj


#
# how to make object files
#
.cpp.obj:
        @echo Compiling $*.cpp
        @$(CC) $(CCFLAGS) $*

#
# make the libraries
#
all: OOLW3W03.dll OOLM3W03.dll OOLT3W03.dll OOLJ3W03.dll OOLRES.RES copydlls

OOLRES.RES: $(OOL)\resource\oolres.rc
        @echo Compiling OOL resource code
	rc -r $(OOL)\resource\oolres.rc

OOLW3W03.dll: $(OBJ_MAIN)
        @echo linking OOLW3W03.DLL
        @echo segment type data nonshared readwrite loadoncall >$(OBJFILE)
        @echo segment type code nonshared loadoncall >>$(OBJFILE)
        @echo file $(LOBJ_MAIN)>>$(OBJFILE)
        @$(LD) name OOLW3W03.dll import WinMessageBox2 PMWIN.1015 $(LDFLAGS) libr rxstring.lib libr rexx.lib
        @wlib -b -n -q OOLW3W03.lib +OOLW3W03.dll
        @copy OOLW3W03.lib $(OOLLIB)>NUL
        @copy OOLW3W03.dll $(OOLLIB)>NUL
        @del $(OBJFILE)

OOLM3W03.dll: $(OBJ_MEDIA)
        @echo linking OOLM3W03.DLL
        @echo segment type data nonshared readwrite loadoncall >$(OBJFILE)
        @echo segment type code nonshared loadoncall >>$(OBJFILE)
        @echo file $(LOBJ_MEDIA)>>$(OBJFILE)
        @$(LD) name OOLM3W03.dll $(LDFLAGS) libr OOLW3W03 libr MMPM2
        @wlib -b -n -q OOLM3W03.lib +OOLM3W03.dll
        @copy OOLM3W03.lib $(OOLLIB)>NUL
        @copy OOLM3W03.dll $(OOLLIB)>NUL
        @del $(OBJFILE)

OOLT3W03.dll: $(OBJ_TCP)
        @echo linking OOLT3W03.DLL
        @echo segment type data nonshared readwrite loadoncall >$(OBJFILE)
        @echo segment type code nonshared loadoncall >>$(OBJFILE)
        @echo file $(LOBJ_TCP)>>$(OBJFILE)
        @$(LD) name OOLT3W03.dll $(LDFLAGS) libr OOLW3W03 libr webexwin
        @wlib -b -n -q OOLT3W03.lib +OOLT3W03.dll
        @copy OOLT3W03.lib $(OOLLIB)>NUL
        @copy OOLT3W03.dll $(OOLLIB)>NUL
        @del $(OBJFILE)

OOLJ3W03.dll: $(OBJ_JAVA)
        @echo linking OOLJ3W03.DLL
        @echo segment type data nonshared readwrite loadoncall >$(OBJFILE)
        @echo segment type code nonshared loadoncall >>$(OBJFILE)
        @echo file $(LOBJ_JAVA)>>$(OBJFILE)
        @$(LD) name OOLJ3W03.dll $(LDFLAGS) libr OOLW3W03 libr jempo10
        @wlib -b -n -q OOLJ3W03.lib +OOLJ3W03.dll
        @copy OOLJ3W03.lib $(OOLLIB)>NUL
        @copy OOLJ3W03.dll $(OOLLIB)>NUL
        @del $(OBJFILE)



#
# uncomment the line below, in order to copy the dll files to \os2\dll
#
copydlls:
#        @copy *.dll f:\os2\dll>NUL

clean:
        @if exist *.obj del *.obj>NUL
        @if exist *.err del *.err>NUL
        @if exist *.dll del *.dll>NUL
        @if exist *.lib del *.lib>NUL



#
# dependencies
#
xapp.obj: xapp.cpp\
	$(OOL)\include\xapp.h\
	$(OOL)\include\xreslib.h\
	$(OOL)\include\xrect.h\
	$(OOL)\include\xframe.h\
	$(OOL)\include\xfrmwnd.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\xmsgbox.h


xbookpg.obj: xbookpg.cpp\
	$(OOL)\include\XNoteBk.h\
	$(OOL)\include\XBookPg.h\
	$(OOL)\include\xcntevnt.h\
	$(OOL)\include\xcolor.h\
	$(OOL)\include\xres.h\
	$(OOL)\include\xreslib.h

xbutton.obj: xbutton.cpp\
	$(OOL)\include\xcheckbx.h\
	$(OOL)\include\xpushbtn.h\
	$(OOL)\include\xradio.h\
	$(OOL)\include\xmoushdl.h\
	$(OOL)\include\xmousevn.h\
	$(OOL)\include\xuserbtn.h\
	$(OOL)\include\xbitmap.h\
	$(OOL)\include\xdefhdl.h\
	$(OOL)\include\xstring.h


xchart.obj: xchart.cpp\
	$(OOL)\include\XPie.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\xrect.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\xstring.h

xcircsld.obj: xcircsld.cpp\
	$(OOL)\include\xcircsld.h

xclipbrd.obj: xclipbrd.cpp\
	$(OOL)\include\XClipBrd.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XBitmap.h\
	$(OOL)\include\XString.h

xcont.obj: xcont.cpp\
	$(OOL)\include\XContInf.h\
	$(OOL)\include\XContObj.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XContain.h\
	$(OOL)\include\XContCol.h\
	$(OOL)\include\XDate.h\
	$(OOL)\include\XTime.h\
	$(OOL)\include\XBitmap.h\
	$(OOL)\include\XIcon.h


xcontain.obj: xcontain.cpp\
	$(OOL)\include\XContain.h\
	$(OOL)\include\XContInf.h\
	$(OOL)\include\XContObj.h\
	$(OOL)\include\XControl.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XContCol.h


xcontrol.obj: xcontrol.cpp\
	$(OOL)\include\XControl.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\XPushBtn.h\
	$(OOL)\include\XDragHdl.h\
	$(OOL)\include\XDragEvn.h\
	$(OOL)\include\XMousHdl.h\
	$(OOL)\include\XMousEvn.h\
	$(OOL)\include\XFrame.h\
	$(OOL)\include\XNoteBk.h\
	$(OOL)\include\XBookPg.h\
	$(OOL)\include\xcolor.h\
	$(OOL)\include\xmsgbox.h

xdate.obj: xdate.cpp\
	$(OOL)\include\xdate.h\
	$(OOL)\include\XString.h


xdde.obj: xdde.cpp\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XDDE.h\
	$(OOL)\include\XDefHdl.h

xentry.obj: xentry.cpp\
	$(OOL)\include\xentry.h

xevent.obj: xevent.cpp\
	$(OOL)\include\XCntrevn.h\
	$(OOL)\include\XDragEvn.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XPoint.h\
	$(OOL)\include\XBitmap.h\
	$(OOL)\include\XDragItm.h\
	$(OOL)\include\XMousevn.h\
	$(OOL)\include\XCntEvnt.h\
	$(OOL)\include\XKeyEvnt.h\
	$(OOL)\include\XContObj.h\
	$(OOL)\include\XcnDrEvn.h\
	$(OOL)\include\XCnEdEvn.h\
	$(OOL)\include\xString.h\
	$(OOL)\include\XContCol.h\
	$(OOL)\include\XItmDEvn.h\
	$(OOL)\include\XBackEvn.h


xfile.obj: xfile.cpp\
	$(OOL)\include\XFileDlg.h\
	$(OOL)\include\XFileInf.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XFile.h\
	$(OOL)\include\XDate.h\
	$(OOL)\include\XTime.h\
	$(OOL)\include\XPipe.h\
	$(OOL)\include\XNPipe.h\
	$(OOL)\include\XcPipe.h

xfilefi.obj: xfilefi.cpp\
	$(OOL)\include\XFileFi.h

xframe.obj: xframe.cpp\
	$(OOL)\include\XFrmWnd.h\
	$(OOL)\include\XFrame.h\
	$(OOL)\include\XFrmCnt.h\
	$(OOL)\include\XScrlBar.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\xmsgbox.h

xfrmcnt.obj: xfrmcnt.cpp\
	$(OOL)\include\XFrmCnt.h\
	$(OOL)\include\XFrmwnd.h\
	$(OOL)\include\XFrame.h


xfrmwnd.obj: xfrmwnd.cpp\
	$(OOL)\include\XFrmwnd.h\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XFrame.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\XCombo.H\
	$(OOL)\include\XMLE.h\
	$(OOL)\include\XSlider.h\
	$(OOL)\include\XEntry.h\
	$(OOL)\include\XCheckBx.h\
	$(OOL)\include\XPushBtn.h\
	$(OOL)\include\XScrlBar.h\
	$(OOL)\include\XSpinBtn.h\
	$(OOL)\include\XListBox.h\
	$(OOL)\include\XCircSld.h\
	$(OOL)\include\XGroupBx.h\
	$(OOL)\include\XSBitmap.h\
	$(OOL)\include\XSIcon.h\
	$(OOL)\include\XSText.h\
	$(OOL)\include\XSFrame.h\
	$(OOL)\include\XValuSet.h\
	$(OOL)\include\XIcon.h\
	$(OOL)\include\XRadio.h\
	$(OOL)\include\XMenuBar.h\
	$(OOL)\include\XContain.h\
	$(OOL)\include\XProcess.h\
	$(OOL)\include\Xcntrevn.h\
	$(OOL)\include\XMedia.h\
	$(OOL)\include\XTimer.h\
	$(OOL)\include\XDragHdl.h\
	$(OOL)\include\XDragEvn.h\
	$(OOL)\include\XMousHdl.h\
	$(OOL)\include\XMousevn.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XContHdl.h\
	$(OOL)\include\XItmDHdl.h\
	$(OOL)\include\XBackHdl.h\
	$(OOL)\include\XStylHdl.h\
	$(OOL)\include\XdefHdl.h\
	$(OOL)\include\XTimer.h\
	$(OOL)\include\XScrlWnd.h\
	$(OOL)\include\XCntEvnt.h\
	$(OOL)\include\XCnEdEvn.h\
	$(OOL)\include\XCndrEvn.h\
	$(OOL)\include\xkeyevnt.h\
	$(OOL)\include\xkeybhdl.h\
	$(OOL)\include\XItmDEvn.h\
	$(OOL)\include\XBackEvn.h\
	$(OOL)\include\XNoteBk.h

xgraphbt.obj: xgraphbt.cpp\
	$(OOL)\include\xgraphbt.h\
	$(OOL)\include\XColor.h


xgraphdv.obj: xgraphdv.cpp\
	$(OOL)\include\XGraphDv.h\
	$(OOL)\include\XGraphOb.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XFont.h\
	$(OOL)\include\xprocess.h

xgraphob.obj: xgraphob.cpp\
	$(OOL)\include\XGraphOb.h\
	$(OOL)\include\XGraphDv.h\
	$(OOL)\include\XLine.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\XFont.h\
	$(OOL)\include\XCircle.h\
	$(OOL)\include\XText.h\
	$(OOL)\include\XBox.h\
	$(OOL)\include\XMarker.h\
	$(OOL)\include\XBitmap.h\
	$(OOL)\include\XFile.h\
	$(OOL)\include\XFileInf.h\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XBmpShad.h\
	$(OOL)\include\XArc.h\
	$(OOL)\include\XFontDlg.h\
	$(OOL)\include\XUserBtn.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\xprocess.h

xhandler.obj: xhandler.cpp\
	$(OOL)\include\XDragHdl.h\
	$(OOL)\include\XDragEvn.h\
	$(OOL)\include\XMousHdl.h\
	$(OOL)\include\XMousevn.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XContHdl.h\
	$(OOL)\include\XItmDHdl.h\
	$(OOL)\include\XBackHdl.h\
	$(OOL)\include\XStylHdl.h\
	$(OOL)\include\XTimer.h


xhelp.obj: xhelp.cpp\
	$(OOL)\include\XHelp.h\
	$(OOL)\include\XFrmwnd.H\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XProcess.h


xlistbox.obj: xlistbox.cpp\
	$(OOL)\include\xlistbox.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\xcombo.h

xmedia.obj: xmedia.cpp\
	$(OOL)\include\XVideo.h\
	$(OOL)\include\XFrmWnd.h\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XSound.h\
	$(OOL)\include\XCntrEvn.h

xmenu.obj: xmenu.cpp\
	$(OOL)\include\XPopMenu.h\
	$(OOL)\include\XMenuBar.h\
	$(OOL)\include\XMenuItm.h\
	$(OOL)\include\XPoint.h\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XFrmWnd.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\xmsgbox.h

xmle.obj: xmle.cpp\
	$(OOL)\include\xmle.h\
	$(OOL)\include\xmlesear.h\
	$(OOL)\include\xstring.h

xmsgbox.obj: xmsgbox.cpp\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XxtMsgBx.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XIcon.h


xobjwnd.obj: xobjwnd.cpp\
	$(OOL)\include\XFrmWnd.h\
	$(OOL)\include\XObjWnd.h

xprofile.obj: xprofile.cpp\
	$(OOL)\include\xprofile.h

xreslib.obj: xreslib.cpp\
	$(OOL)\include\XRes.h\
	$(OOL)\include\XResLib.h\
	$(OOL)\include\XApp.h\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XMsgBox.h\
	$(OOL)\include\XIcon.h

xscrlbar.obj: xscrlbar.cpp\
	$(OOL)\include\xscrlbar.h

xscrlwnd.obj: xscrlwnd.cpp\
	$(OOL)\include\XScrlWnd.h\
	$(OOL)\include\xrect.h\
	$(OOL)\include\XScrlBar.h\
	$(OOL)\include\XFrame.h\
	$(OOL)\include\XDefhdl.h

xslider.obj: xslider.cpp\
	$(OOL)\include\xslider.h\
	$(OOL)\include\xstring.h

xspinbtn.obj: xspinbtn.cpp\
	$(OOL)\include\xspinbtn.h

xstring.obj: xstring.cpp\
	$(OOL)\include\XString.h


xthread.obj: xthread.cpp\
	$(OOL)\include\xthread.h\
	$(OOL)\include\xmsgbox.h

xtime.obj: xtime.cpp\
	$(OOL)\include\xtime.h\
	$(OOL)\include\xstring.h


xtoolbar.obj: xtoolbar.cpp\
	$(OOL)\include\XToolBar.h\
	$(OOL)\include\XFrmWnd.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\XFrame.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\XGraphDv.H\
	$(OOL)\include\XLine.h\
	$(OOL)\include\XCntrEvn.h\
	$(OOL)\include\XMousHdl.h\
	$(OOL)\include\XMousevn.h\
	$(OOL)\include\XReslib.h


xuserwnd.obj: xuserwnd.cpp\
	$(OOL)\include\xgraphdv.h\
	$(OOL)\include\xmoushdl.h\
	$(OOL)\include\xres.h\
	$(OOL)\include\xprocess.h\
	$(OOL)\include\xfont.h\
	$(OOL)\include\xmousevn.h\
	$(OOL)\include\XText.h\
	$(OOL)\include\xuserwnd.h\
	$(OOL)\include\xrect.h\
	$(OOL)\include\xcntrevn.h\
	$(OOL)\include\xreslib.h\
	$(OOL)\include\xbubble.h\
	$(OOL)\include\xtimer.h\
	$(OOL)\include\xbitmap.h

xvaluset.obj: xvaluset.cpp\
	$(OOL)\include\xvaluset.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\xcolor.h\
	$(OOL)\include\xicon.h\
	$(OOL)\include\xbitmap.h

xwebview.obj: xwebview.cpp\
	$(OOL)\include\XControl.h\
	$(OOL)\include\XWebView.h\
	$(OOL)\include\xmsgbox.h\
	$(OOL)\include\webexwin.h\
	$(OOL)\include\xstring.h\
	$(OOL)\include\XDefHdl.h

xwindow.obj: xwindow.cpp\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XString.h\
	$(OOL)\include\XRect.h\
	$(OOL)\include\XColor.h\
	$(OOL)\include\XHandler.h\
	$(OOL)\include\XPoint.h

xwindrag.obj: xwindrag.cpp\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\XWinDrag.h\
	$(OOL)\include\XDragItm.h\
	$(OOL)\include\XBitmap.h\
	$(OOL)\include\XIcon.h

xrexx.obj: xrexx.cpp\
	$(OOL)\include\xrexx.h

xprint.obj: xprint.cpp\
	$(OOL)\include\xgraphdv.h\
	$(OOL)\include\xprint.h

xjavaenv.obj: xjavaenv.cpp\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\xjavaenv.h

xjvcmsgh.obj: xjvcmsgh.cpp\
	$(OOL)\include\XWindow.h\
	$(OOL)\include\xjvcmsgh.h

xjavaapp.obj: xjavaapp.cpp\
	$(OOL)\include\xjavaapp.h

xjvsmsgh.obj: xjvsmsgh.cpp\
	$(OOL)\include\xjvsmsgh.h

xjvsurlh.obj: xjvsurlh.cpp\
	$(OOL)\include\xjvsurlh.h

xblitter.obj: xblitter.cpp\
        $(OOL)\include\xblitter.h

xbltwnd.obj: xbltwnd.cpp\
        $(OOL)\include\xbltwnd.h

xpal.obj: xpal.cpp\
        $(OOL)\include\xpal.h

xvirtscr.obj: xvirtscr.cpp\
        $(OOL)\include\xvirtscr.h

